<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart                                                                      |
| Copyright (c) 2001-2011 Ruslan R. Fazlyev <rrf@x-cart.com>                  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  RUSLAN  R. |
| FAZLYEV (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  OR MAKING |
| AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE  "SOFTWARE").   |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Ruslan R. Fazlyev             |
| Portions created by Ruslan R. Fazlyev are Copyright (C) 2001-2011           |
| Ruslan R. Fazlyev. All Rights Reserved.                                     |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Templater plugin
 * -------------------------------------------------------------
 * Type:     function
 * Name:     interline
 * Input:    class
 *           total
 *           index
 *            additional_class
 * -------------------------------------------------------------
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Lib
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-2011 Ruslan R. Fazlyev <rrf@x-cart.com>
 * @license    http://www.x-cart.com/license.php X-Cart license agreement
 * @version    $Id: function.interline.php,v 1.18.2.2 2011/01/10 13:11:53 ferz Exp $
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) { header("Location: ../../../"); die("Access denied"); }

function smarty_function_interline($params, &$smarty)
{
    if (
        (
            isset($params['class']) 
            && (
                !is_string($params['class']) 
                || empty($params['class'])
            )
        ) || (
            (
                !isset($params['name']) 
                || !is_string($params['name']) 
                || empty($params['name']) 
                || !isset($smarty->_foreach[$params['name']])
            ) && (
                !isset($params['total']) 
                || !is_int($params['total']) 
                || $params['total'] < 1 
                || !isset($params['index']) 
                || !is_int($params['index']) 
                || $params['index'] < 0 
                || $params['index'] > $params['total'] - 1
            )
        )
    ) {
        return '';
    }

    if (isset($params['name'])) {
        $params['total'] = $smarty->_foreach[$params['name']]['total'];
        $params['index'] = max(0, $smarty->_foreach[$params['name']]['iteration'] - 1);
    }

    if (!isset($params['class']) && empty($params['skip_highlight']))
        $params['class'] = 'highlight';

    $class = array();

    if ($params['total'] % 2 == ($params['index'] + 1) % 2)
        $class[] = $params['class'];

    if ($params['index'] == 0)
        $class[] = 'first';

    if ($params['index'] >= $params['total'] - 1)
        $class[] = 'last';

    if (!empty($params['additional_class']))
        $class[] = $params['additional_class'];

    $class = implode(" ", $class);

    if (!empty($class) && (!isset($params['pure']) || !$params['pure']))
        $class = ' class="' . $class . '"';

    if (isset($params['assign'])) {
        $smarty->assign($params['assign'], $class);
        $class = '';
    }

    return $class;
}

?>
